package JCAT;

import java.io.*;


class Configure implements Commands
{
    private static String j2sDir  = System.getProperty("d1");
    private static String spinDir = System.getProperty("d2");
    private static String ccDir   = System.getProperty("d3");
    private static String timeDir = System.getProperty("d4");
    private static String bashDir = System.getProperty("d5");
    private static String jadDir  = System.getProperty("d6");
    
    public static boolean j2sAvail;
    public static boolean spinAvail;
    public static boolean ccAvail;
    public static boolean timeAvail;
    public static boolean bashAvail;
    public static boolean jadAvail;


    public static void warning(String[] s)
    {
	System.out.println("");

	for (int i = 0; i < s.length; i ++)
	    System.out.println("*** " + s[i] + " ***");
    }


    private static boolean checkFile(String dir, String name)
    {
	File file = new File (dir, name);
	System.out.print("Looking up " + dir + "/" + name + " ... ");

	try {
	    if (file.exists()) {
		System.out.println("yes");
		return true;
	    }
	    else { 
		System.out.println("no");
		return false;
	    }
	} catch (SecurityException e) { 
	    return false; 
	}
    }
  
    public static boolean checkConfiguration()
    {
	j2sAvail  = checkFile(j2sDir, j2s_);
	spinAvail = checkFile(spinDir, spin_);
	ccAvail   = checkFile(ccDir, cc_);
	timeAvail = checkFile(timeDir, time_);
	bashAvail = checkFile(bashDir, bash_);
	jadAvail  = checkFile(jadDir, jad_);

	if (!j2sAvail || !spinAvail || !bashAvail)
	    return false;

	if (!ccAvail) {
	    String s[] = {"No C compiler found         ",
			  "You can only run simulations"};
	    warning(s);
	}

	if (!timeAvail) {
	    String s[] = {"No time utility found            ",
			  "You will not get time information"};
	    warning(s);
	}

	if (!jadAvail) {
	    String s[] = {"No Java decompiler found                ",
			  "You will not be able to read class files"};
	    warning(s);
	}
	
	return true;
    }
}

