package JCAT;
import java.awt.*;


class Decompiler implements Commands 
{
    private TextArea editOut;
    private TextArea editErr;
    private Label    footLabel;

    private String bash_path;
    private String jad_path;

    private String _dir;
    private String _path;

    Decompiler(DirBox dirBox, TextArea out, TextArea err,
	       Label label, String dir, String path)
    {
	bash_path = dirBox.getBashDir() + "/" + bash_;
	jad_path  = dirBox.getJadDir() + "/" + jad_ + " -d " + dir 
	    + " -o " + path;

	editOut   = out;
	editErr   = err;
	footLabel = label;

	_dir  = dir;
	_path = path;
    }

    
    public boolean decompile()
    {
	Runtime rt_   = Runtime.getRuntime();
	String cmd [] = {bash_path, "-c", jad_path};
	Process proc;

	footLabel.setText("Decompiling " + _path + " ...");

	try {
	    proc = rt_.exec(cmd);
	} catch(Exception e) {
	    editErr.appendText(e.getMessage() + "\n");
	    footLabel.setText("Errors");
	    return false;
	}

	Printer out = new Printer(editOut, proc.getErrorStream());

	out.start();
		
	try {
	    proc.waitFor();
	} catch(InterruptedException e) {
	    editErr.appendText(e.getMessage() + "\n");
	    footLabel.setText("Errors");
	    return false;
	}
	
	try {
	    out.join();
	} catch(InterruptedException e) {
	    editErr.appendText(e.getMessage() + "\n");
	    footLabel.setText("Errors");
	    return false;
	}

	footLabel.setText("Ready");
	return true;
    }
}
