package JCAT;
import java.awt.*;

public class J2SBox extends Dialog {
    private boolean lock_ = false;
    private boolean all_ = true;
    private boolean fast_ = true;

    private Integer instances = new Integer(10);
    private Integer arraySize = new Integer(10);
  
    private String mainClass = new String("Main");
    private String other = "";
  
    private String options;
  
    public String getOptions()
    {
	options = (fast_ ? "-f " : "") +
	    (all_  ? "-a " : "") +
	    (lock_ ? "-l " : "") +
	    "-i" + instances + " " +
	    "-s" + arraySize + " " +
	    "-c " + mainClass + " " +
	    other + " ";
    
	return options;
    }

    public J2SBox(Frame parent) {
    
	super(parent, "Java2Spin options", true);
    
	//{{INIT_CONTROLS
	setLayout(null);
	addNotify();
	resize(insets().left + insets().right + 481, insets().top + insets().bottom + 287);

	labelMaxArray=new Label("Max array size:");
	labelMaxArray.setFont(new Font("Dialog", Font.BOLD, 8));
	add(labelMaxArray);
	labelMaxArray.reshape(insets().left + 7,insets().top + 13,105,26);

	labelMaxInstances=new Label("Max instances:");
	labelMaxInstances.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelMaxInstances);
	labelMaxInstances.reshape(insets().left + 7,insets().top + 52,105,26);

	labelMainClass=new Label("Main class name:");
	labelMainClass.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelMainClass);
	labelMainClass.reshape(insets().left + 7,insets().top + 130,105,26);

	editMainClass=new TextField(mainClass, 21);
	editMainClass.setFont(new Font("Dialog",Font.BOLD,8));
	add(editMainClass);
	editMainClass.reshape(insets().left + 126,insets().top + 130,175,26);

	checkFast=new Checkbox("Generate fast description", null, fast_);
	checkFast.setFont(new Font("Dialog",Font.BOLD,8));
	add(checkFast);
	checkFast.reshape(insets().left + 196,insets().top + 13,210,26);

	checkAll=new Checkbox("Models all variables", null, all_);
	checkAll.setFont(new Font("Dialog",Font.BOLD,8));
	add(checkAll);
	checkAll.reshape(insets().left + 196,insets().top + 52,210,26);

	checkLock=new Checkbox("Models atomic lock ", null, lock_);
	checkLock.setFont(new Font("Dialog",Font.BOLD,8));
	add(checkLock);
	checkLock.reshape(insets().left + 196,insets().top + 91,210,26);

	editMaxInstances=new TextField(instances.toString(), 5);
	editMaxInstances.setFont(new Font("Dialog",Font.BOLD, 8));
	add(editMaxInstances);
	editMaxInstances.reshape(insets().left + 126,insets().top + 52,28,26);

	editMaxArray=new TextField(arraySize.toString(), 5);
	editMaxArray.setFont(new Font("Dialog",Font.BOLD, 8));
	add(editMaxArray);
	editMaxArray.reshape(insets().left + 126,insets().top + 13,28,26);

	OKButton=new Button("Okay");
	add(OKButton);
	OKButton.reshape(insets().left + 217,insets().top + 221,77,32);

	cancelButton=new Button("Cancel");
	add(cancelButton);
	cancelButton.reshape(insets().left + 315,insets().top + 221,77,32);

	labelOther=new Label("Other options:");
	labelOther.setFont(new Font("Dialog",Font.BOLD, 8));
	add(labelOther);
	labelOther.reshape(insets().left + 7,insets().top + 175,105,26);

	editOther=new TextField(other, 21);
	editOther.setFont(new Font("Dialog",Font.BOLD, 8));
	add(editOther);
	editOther.reshape(insets().left + 126,insets().top + 175,175,26);
	//}}
    
	setResizable(false);
    }

    public synchronized void show() {
	Rectangle bounds = getParent().bounds();
	Rectangle abounds = bounds();
    
	move(bounds.x + (bounds.width - abounds.width)/ 2,
	     bounds.y + (bounds.height - abounds.height)/2);
    
	super.show();
    }

    public synchronized void wakeUp() {
	notify();
    }
  
    public boolean handleEvent(Event event) {
	if (event.id == Event.ACTION_EVENT && event.target == OKButton) {
	    clickedOKButton();
	    return true;
	}
	else
	    if (event.id == Event.ACTION_EVENT && event.target == cancelButton) {
		clickedCancelButton();
		return true;
	    }
	    else
	
		if (event.id == Event.WINDOW_DESTROY) {
		    hide();
		    return true;
		}
	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    Label labelMaxInstances;
    Label labelMainClass;
    TextField editMainClass;
    TextField editMaxArray;
    Checkbox checkFast;
    Checkbox checkAll;
    Checkbox checkLock;
    Label labelMaxArray;
    TextField editMaxInstances;
    Button OKButton;
    Button cancelButton;
    Label labelOther;
    TextField editOther;
    //}}
  
    public void clickedCancelButton() {
	hide();
    }

  
    public void clickedOKButton() {
	fast_ = checkFast.getState();
	all_  = checkAll.getState();
	lock_ = checkLock.getState();
	other = editOther.getText();
    
	try {
	    instances = new Integer(editMaxInstances.getText());
	    arraySize = new Integer(editMaxArray.getText());
	} catch (NumberFormatException e) {return;}
    
	mainClass = editMainClass.getText();

	hide();
    }
}


