package JCAT;

%%

%{
  private SpinOut spinOut;

  private String cutTo(String del)
    {
      String s = yytext();
      int index = s.indexOf(del);
      return s.substring(0, index);
    }

  public SpinOut getOutput()
    {
      return spinOut;
    }
%}

%init{
  spinOut = new SpinOut();
%init}

%integer
%class OutLex

%state VERSION
%state VECTOR
%state DEPTH
%state ERRORS

%%

<YYINITIAL>"(Spin Version "   		{ yybegin(VERSION); }
<VERSION>[0-9.]+              		{ 
                                  	spinOut.setVersion(yytext());
			          	yybegin(YYINITIAL);
                              		}

<YYINITIAL>"State-vector "    		{ yybegin(VECTOR); }
<VECTOR>[0-9]+                		{
                                  	spinOut.setVector(yytext());
			          	yybegin(YYINITIAL);
                              		}

<YYINITIAL>"depth reached "   		{ yybegin(DEPTH); }
<DEPTH>[0-9]+                 		{
                                  	spinOut.setDepth(yytext());  
			          	yybegin(YYINITIAL);
                              		}

<YYINITIAL>"errors: "                 	{ yybegin(ERRORS); }
<ERRORS>[0-9]+                        	{
                                        spinOut.setErrors(yytext()); 
				        yybegin(YYINITIAL);
                                      	}

<YYINITIAL>[0-9]+" states, stored"    	{
					spinOut.setStored(cutTo(" states"));
					}

<YYINITIAL>[0-9]+" states, matched"     {
					spinOut.setMatched(cutTo(" states"));
					}

<YYINITIAL>[0-9]+" transitions" 	{
					spinOut.setTransitions(cutTo(" tran"));
					}

<YYINITIAL>[0-9]+" atomic steps"	{
					spinOut.setAtomic(cutTo(" atomic"));
					}

<YYINITIAL>"pan: out of memory"         {
                                        spinOut.setOutOfMemory();
                                        }

<YYINITIAL>"pan: assertion violated"    {
                                        spinOut.setAssertion();
                                        }

<YYINITIAL>"pan: invalid endstate"      {
                                        spinOut.setEndState();
                                        }

.|\n                          		{}
