package JCAT;
import java.awt.*;

public class PanCompBox extends Dialog {

    private Integer size = new Integer(1000000);
    private boolean safety_ = true;
    private boolean bitstate_ = false;
    private String other = "";

    private String options;

    public String getOptions()
    {
	options = "-DVECTORSZ=" + size + " " +
	    (safety_ ? "-DSAFETY " : "") +
	    (bitstate_ ? "-DBITSTATE " : "") +
	    other;

	return options;
    }
  
    public PanCompBox(Frame parent) {

	super(parent, "Pan compilation options", true);

	//{{INIT_CONTROLS
	setLayout(null);
	addNotify();
	resize(insets().left + insets().right + 406, insets().top + insets().bottom + 274);
	OKButton=new Button("Okay");
	add(OKButton);
	OKButton.reshape(insets().left + 189,insets().top + 202,77,32);
	cancelButton=new Button("Cancel");
	add(cancelButton);
	cancelButton.reshape(insets().left + 287,insets().top + 202,77,32);
	labelVectorSize=new Label("Max vector size:");
	labelVectorSize.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelVectorSize);
	labelVectorSize.reshape(insets().left + 14,insets().top + 20,105,26);
	editMaxVector=new TextField(size.toString(), 19);
	editMaxVector.setFont(new Font("Dialog",Font.BOLD,8));
	add(editMaxVector);
	editMaxVector.reshape(insets().left + 133,insets().top + 20,161,26);
	checkSafety=new Checkbox("Safety checks", null, safety_);
	checkSafety.setFont(new Font("Dialog",Font.BOLD,8));
	add(checkSafety);
	checkSafety.reshape(insets().left + 28,insets().top + 72,182,32);
	checkBitState=new Checkbox("Bit state hashing", null, bitstate_);
	checkBitState.setFont(new Font("Dialog",Font.BOLD,8));
	add(checkBitState);
	checkBitState.reshape(insets().left + 28,insets().top + 104,182,33);
	labelOther=new Label("Other options:");
	labelOther.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelOther);
	labelOther.reshape(insets().left + 14,insets().top + 156,105,26);
	editOther=new TextField(other, 19);
	editOther.setFont(new Font("Dialog",Font.BOLD,8));
	add(editOther);
	editOther.reshape(insets().left + 133,insets().top + 156,161,26);
	//}}
    
	setResizable(false);
    }

    public synchronized void show() {
	Rectangle bounds = getParent().bounds();
	Rectangle abounds = bounds();
    
	move(bounds.x + (bounds.width - abounds.width)/ 2,
	     bounds.y + (bounds.height - abounds.height)/2);
    
	super.show();
    }

    public synchronized void wakeUp() {
	notify();
    }

    public boolean handleEvent(Event event) {
	if (event.id == Event.ACTION_EVENT && event.target == OKButton) {
	    clickedOKButton();
	    return true;
	}
	else
	    if (event.id == Event.ACTION_EVENT && event.target == cancelButton) {
		clickedCancelButton();
		return true;
	    }
	    else
	
		if (event.id == Event.WINDOW_DESTROY) {
		    hide();
		    return true;
		}
	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    Button OKButton;
    Button cancelButton;
    Label labelVectorSize;
    TextField editMaxVector;
    Checkbox checkSafety;
    Checkbox checkBitState;
    Label labelOther;
    TextField editOther;
    //}}

    public void clickedCancelButton() {
	hide();
    }

    public void clickedOKButton() {
	try {
	    size = new Integer(editMaxVector.getText());
	} catch (NumberFormatException e) {return;}
    
	safety_   = checkSafety.getState();
	bitstate_ = checkBitState.getState();

	other = editOther.getText();

	hide();
    }
}


