package JCAT;
import java.awt.*;


public class PanExecBox extends Dialog {

    private Integer maxdepth = new Integer(10000);
    private boolean allerr_ = false;
    private String other = "";

    private String options;


    public String getOptions()
    {
	options = (allerr_ ? "-c0 " : "") + "-m" + maxdepth + " " + other;
	return options;
    }


    public PanExecBox(Frame parent) {

	super(parent, "Pan execution options", true);

	//{{INIT_CONTROLS
	setLayout(null);
	addNotify();
	resize(insets().left + insets().right + 378, insets().top + insets().bottom + 218);
	labelDepthSearch=new Label("Max search depth:");
	add(labelDepthSearch);
	labelDepthSearch.reshape(insets().left + 14,insets().top + 13,140,26);
	editMaxDepth=new TextField(maxdepth.toString(), 19);
	editMaxDepth.setFont(new Font("Dialog",Font.BOLD,8));
	add(editMaxDepth);
	editMaxDepth.reshape(insets().left + 154,insets().top + 13,161,26);
	OKButton=new Button("Okay");
	add(OKButton);
	OKButton.reshape(insets().left + 189,insets().top + 150,77,32);
	cancelButton=new Button("Cancel");
	add(cancelButton);
	cancelButton.reshape(insets().left + 287,insets().top + 150,77,32);
	checkAllSearch=new Checkbox("Search for all errors", null, allerr_);
	add(checkAllSearch);
	checkAllSearch.reshape(insets().left + 14,insets().top + 52,196,26);
	labelOther=new Label("Other options:");
	add(labelOther);
	labelOther.reshape(insets().left + 14,insets().top + 98,105,26);
	editOther=new TextField(other, 22);
	editOther.setFont(new Font("Dialog",Font.BOLD,8));
	add(editOther);
	editOther.reshape(insets().left + 156,insets().top + 94,182,30);
	//}}
    
	setResizable(false);
    }
  
    public synchronized void show() {
	Rectangle bounds = getParent().bounds();
	Rectangle abounds = bounds();
    
	move(bounds.x + (bounds.width - abounds.width)/ 2,
	     bounds.y + (bounds.height - abounds.height)/2);
    
	super.show();
    }
  
    public synchronized void wakeUp() {
	notify();
    }
  
    public boolean handleEvent(Event event) {
	if (event.id == Event.ACTION_EVENT && event.target == OKButton) {
	    clickedOKButton();
	    return true;
	}
	else
	    if (event.id == Event.ACTION_EVENT && event.target == cancelButton) {
		clickedCancelButton();
		return true;
	    }
	    else
	
		if (event.id == Event.WINDOW_DESTROY) {
		    hide();
		    return true;
		}

	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    Label labelDepthSearch;
    TextField editMaxDepth;
    Button OKButton;
    Button cancelButton;
    Checkbox checkAllSearch;
    Label labelOther;
    TextField editOther;
    //}}

    public void clickedCancelButton() {
	hide();
    }

    public void clickedOKButton() {
	try {
	    maxdepth = new Integer(editMaxDepth.getText());
	} catch (NumberFormatException e) {return;}
    
	allerr_ = checkAllSearch.getState();
	other   = editOther.getText();
    
	hide();
    }
}


