package JCAT;

import java.awt.*;

public class ThreadFrame extends Frame {

    private List listMain;
    private FileLoader file_;
    private int line_;


    public ThreadFrame() {
    
	super();

	setLayout(new BorderLayout());
	addNotify();
	resize(insets().left + insets().right + 430, 
	       insets().top + insets().bottom + 310);

	listMain = new List();
	listMain.setFont(new Font("Dialog", Font.BOLD, 10));
	add("Center", listMain);
	listMain.reshape(insets().left + 6,insets().top + 6, 400, 300);

	file_ = null;
	line_ = 0;
    }


    public synchronized void show() {
	super.show();
    }


    public boolean handleEvent(Event event) {

	if (event.id == Event.WINDOW_DESTROY)
	    return true;

	if ((event.id == Event.LIST_SELECT) && (event.target == listMain))
	    return true;

	if ((event.id == Event.LIST_DESELECT) && (event.target == listMain))
	    return true;

	return super.handleEvent(event);
    }


    public boolean refresh(FileLoader fl, int l)
    {
	if ((file_ == fl) && (line_ == l))
	    return false;

	line_ = l;

	if (file_ != fl) {
	    file_ = fl;
   
	    if (listMain.countItems() > 0)
		listMain.clear();
      
	    for (int i = 0; i < file_.getSize(); i ++)
		listMain.addItem(file_.lineAt(i));
	}

	listMain.select(line_ - 1);
	listMain.makeVisible(line_ - 1);

	return true;
    }  
}


