package JCAT;
import java.io.*;

%%


%{
  private SpinTrail spinTrail;
  private SpinTrailLine line;


  public TrailLex(InputStream s, LineContainer c)
    {
      this(s);
      spinTrail = new SpinTrail(c);
    }


  private String cutTo(String del)
    {
      String s = yytext();
      int index = s.indexOf(del);
      return s.substring(0, index);
    }

  
  public SpinTrail getTrail()
    {
      return spinTrail;
    }
%}


%eof{
  spinTrail.addLine(new SpinTrailLine(SpinTrailLine.END_OF_TRAIL));
%eof}


%integer
%class TrailLex


%state PROC
%state NAME
%state ACTION
%state CREATE_NUM
%state CREATE_NAME
%state SEQ_LINE
%state SEQ_STATE

%%

<YYINITIAL>[0-9]+":"\t"proc"" "+       {
				       line = new SpinTrailLine(cutTo(":"));
				       yybegin(PROC);
                                       }

<PROC>([0-9]+|-)" ("                   {
				       line.setProcNumber(cutTo(" "));
				       yybegin(NAME);
                                       }

<NAME>[^)]+") "                        {
				       line.setProcName(cutTo(")"));
				       yybegin(ACTION);
                                       }

<ACTION>"terminates"                   {
                                       line.setTag(
                                                SpinTrailLine.PROC_TERMINATES
						  );
                                       spinTrail.addLine(line);
                                       yybegin(YYINITIAL);
                                       }


<ACTION>"creates proc  "               {
                                       line.setTag(SpinTrailLine.PROC_CREATE);
                                       yybegin(CREATE_NUM);
                                       }

<CREATE_NUM>[0-9]+" ("                 {
                                       line.setCreateNumber(cutTo(" "));
                                       yybegin(CREATE_NAME);
                                       }

<CREATE_NAME>[^)]+")"                  {
                                       line.setCreateName(cutTo(")"));
                                       spinTrail.addLine(line);
                                       yybegin(YYINITIAL);
                                       }

<ACTION>"line "                        {
                                       line.setTag(SpinTrailLine.PROC_SEQ);
                                       yybegin(SEQ_LINE);
                                       }

<SEQ_LINE>[0-9]+" ".*"(state "         {
                                       line.setLineNo(cutTo(" "));
                                       yybegin(SEQ_STATE);
                                       }

<SEQ_STATE>[0-9]+                      {
                                       line.setState(yytext());
                                       spinTrail.addLine(line);
                                       yybegin(YYINITIAL);
                                       }

<YYINITIAL>"timeout"                   {
                                       int t = SpinTrailLine.TIMEOUT;
                                       spinTrail.addLine(new SpinTrailLine(t));
                                       }

<YYINITIAL>.|\n                        {
                                       }


