package JCAT;
import java.io.*;


class TrailLex {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 128;
	private final int YY_EOF = 129;
	public final int YYEOF = -1;

  private SpinTrail spinTrail;
  private SpinTrailLine line;
  public TrailLex(InputStream s, LineContainer c)
    {
      this(s);
      spinTrail = new SpinTrail(c);
    }
  private String cutTo(String del)
    {
      String s = yytext();
      int index = s.indexOf(del);
      return s.substring(0, index);
    }
  public SpinTrail getTrail()
    {
      return spinTrail;
    }
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private boolean yy_at_bol;
	private int yy_lexical_state;

	TrailLex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	TrailLex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private TrailLex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private void yy_do_eof () {
		if (false == yy_eof_done) {

  spinTrail.addLine(new SpinTrailLine(SpinTrailLine.END_OF_TRAIL));
		}
		yy_eof_done = true;
	}
	private final int SEQ_STATE = 7;
	private final int CREATE_NUM = 4;
	private final int ACTION = 3;
	private final int YYINITIAL = 0;
	private final int PROC = 1;
	private final int CREATE_NAME = 5;
	private final int NAME = 2;
	private final int SEQ_LINE = 6;
	private final int yy_state_dtrans[] = {
		0,
		27,
		31,
		34,
		60,
		63,
		65,
		69
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NOT_ACCEPT,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NOT_ACCEPT,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NOT_ACCEPT,
		/* 19 */ YY_NOT_ACCEPT,
		/* 20 */ YY_NOT_ACCEPT,
		/* 21 */ YY_NOT_ACCEPT,
		/* 22 */ YY_NOT_ACCEPT,
		/* 23 */ YY_NOT_ACCEPT,
		/* 24 */ YY_NOT_ACCEPT,
		/* 25 */ YY_NOT_ACCEPT,
		/* 26 */ YY_NOT_ACCEPT,
		/* 27 */ YY_NOT_ACCEPT,
		/* 28 */ YY_NOT_ACCEPT,
		/* 29 */ YY_NOT_ACCEPT,
		/* 30 */ YY_NOT_ACCEPT,
		/* 31 */ YY_NOT_ACCEPT,
		/* 32 */ YY_NOT_ACCEPT,
		/* 33 */ YY_NOT_ACCEPT,
		/* 34 */ YY_NOT_ACCEPT,
		/* 35 */ YY_NOT_ACCEPT,
		/* 36 */ YY_NOT_ACCEPT,
		/* 37 */ YY_NOT_ACCEPT,
		/* 38 */ YY_NOT_ACCEPT,
		/* 39 */ YY_NOT_ACCEPT,
		/* 40 */ YY_NOT_ACCEPT,
		/* 41 */ YY_NOT_ACCEPT,
		/* 42 */ YY_NOT_ACCEPT,
		/* 43 */ YY_NOT_ACCEPT,
		/* 44 */ YY_NOT_ACCEPT,
		/* 45 */ YY_NOT_ACCEPT,
		/* 46 */ YY_NOT_ACCEPT,
		/* 47 */ YY_NOT_ACCEPT,
		/* 48 */ YY_NOT_ACCEPT,
		/* 49 */ YY_NOT_ACCEPT,
		/* 50 */ YY_NOT_ACCEPT,
		/* 51 */ YY_NOT_ACCEPT,
		/* 52 */ YY_NOT_ACCEPT,
		/* 53 */ YY_NOT_ACCEPT,
		/* 54 */ YY_NOT_ACCEPT,
		/* 55 */ YY_NOT_ACCEPT,
		/* 56 */ YY_NOT_ACCEPT,
		/* 57 */ YY_NOT_ACCEPT,
		/* 58 */ YY_NOT_ACCEPT,
		/* 59 */ YY_NOT_ACCEPT,
		/* 60 */ YY_NOT_ACCEPT,
		/* 61 */ YY_NOT_ACCEPT,
		/* 62 */ YY_NOT_ACCEPT,
		/* 63 */ YY_NOT_ACCEPT,
		/* 64 */ YY_NOT_ACCEPT,
		/* 65 */ YY_NOT_ACCEPT,
		/* 66 */ YY_NOT_ACCEPT,
		/* 67 */ YY_NOT_ACCEPT,
		/* 68 */ YY_NOT_ACCEPT,
		/* 69 */ YY_NOT_ACCEPT,
		/* 70 */ YY_NOT_ACCEPT,
		/* 71 */ YY_NOT_ACCEPT,
		/* 72 */ YY_NOT_ACCEPT,
		/* 73 */ YY_NOT_ACCEPT,
		/* 74 */ YY_NOT_ACCEPT,
		/* 75 */ YY_NOT_ACCEPT,
		/* 76 */ YY_NOT_ACCEPT
	};
	private int yy_cmap[] = unpackFromString(1,130,
"21:9,3,23,21:2,11,21:18,8,21:7,10,12,21:3,9,21:2,1:10,2,21:38,18,21,7,21,14" +
",21:3,16,21:2,20,15,17,6,4,21,5,19,13,22,21:10,0:2")[0];

	private int yy_rmap[] = unpackFromString(1,77,
"0,1,2,1,3,1:7,4,5,2,1,6,7,8,9,10,11,12,13,14,15,3,16,17,18,19,20,21,22,23,2" +
"4,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,4" +
"9,50,51,52,53,54,55,4,56,57,58,59,60,61,62,63,64")[0];

	private int yy_nxt[][] = unpackFromString(65,24,
"1,2,15:9,-1,15,17,15:10,-1:25,14,16,-1:29,4,-1:16,67:9,76,-1,67:11,-1:2,13," +
"-1:25,19,-1:36,18,-1:22,20,-1:12,21,-1:33,22,-1:14,70,-1:24,23,-1:39,25,-1:" +
"8,26,-1:29,3,-1:10,1,28,-1:7,29,-1:15,28,-1:6,30,-1:23,30,-1:25,5,-1:13,1,3" +
"2:11,-1,32:11,-1,32:11,33,32:11,-1:8,6,-1:15,1,-1:6,35,-1:5,36,-1:6,37,-1:8" +
",71,-1:32,38,-1:25,39,-1:12,41,-1:35,42,-1:24,43,-1:20,44,-1:22,45,-1:22,46" +
",-1:26,47,-1:15,7,-1:29,48,-1:26,49,-1:25,50,-1:22,51,-1:13,52,-1:28,53,-1:" +
"14,54,-1:33,55,-1:14,56,-1:37,8,-1:10,57,-1:24,58,-1:24,59,-1:23,9,-1:15,1," +
"61,-1:23,61,-1:6,62,-1:25,10,-1:13,1,64:11,-1,64:11,-1,64:11,11,64:11,1,66," +
"-1:23,66,-1:6,67,-1:16,67:7,12,67,76,-1,67:11,-1,1,13,-1:28,24,-1:31,40,-1:" +
"10,67:9,76,-1,67:2,68,67:8,-1:2,67:9,76,-1,67,72,67:9,-1:2,67:9,76,-1,67:6," +
"73,67:4,-1:2,67:9,76,-1,67,74,67:9,-1:2,67:9,76,-1,67:7,75,67:3,-1");

	public int yylex ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {
				yy_do_eof();
				return YYEOF;
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{
                                       }
					case -3:
						break;
					case 3:
						{
                                       int t = SpinTrailLine.TIMEOUT;
                                       spinTrail.addLine(new SpinTrailLine(t));
                                       }
					case -4:
						break;
					case 4:
						{
				       line = new SpinTrailLine(cutTo(":"));
				       yybegin(PROC);
                                       }
					case -5:
						break;
					case 5:
						{
				       line.setProcNumber(cutTo(" "));
				       yybegin(NAME);
                                       }
					case -6:
						break;
					case 6:
						{
				       line.setProcName(cutTo(")"));
				       yybegin(ACTION);
                                       }
					case -7:
						break;
					case 7:
						{
                                       line.setTag(SpinTrailLine.PROC_SEQ);
                                       yybegin(SEQ_LINE);
                                       }
					case -8:
						break;
					case 8:
						{
                                       line.setTag(
                                                SpinTrailLine.PROC_TERMINATES
						  );
                                       spinTrail.addLine(line);
                                       yybegin(YYINITIAL);
                                       }
					case -9:
						break;
					case 9:
						{
                                       line.setTag(SpinTrailLine.PROC_CREATE);
                                       yybegin(CREATE_NUM);
                                       }
					case -10:
						break;
					case 10:
						{
                                       line.setCreateNumber(cutTo(" "));
                                       yybegin(CREATE_NAME);
                                       }
					case -11:
						break;
					case 11:
						{
                                       line.setCreateName(cutTo(")"));
                                       spinTrail.addLine(line);
                                       yybegin(YYINITIAL);
                                       }
					case -12:
						break;
					case 12:
						{
                                       line.setLineNo(cutTo(" "));
                                       yybegin(SEQ_STATE);
                                       }
					case -13:
						break;
					case 13:
						{
                                       line.setState(yytext());
                                       spinTrail.addLine(line);
                                       yybegin(YYINITIAL);
                                       }
					case -14:
						break;
					case 15:
						{
                                       }
					case -15:
						break;
					case 17:
						{
                                       }
					case -16:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
