package JCAT;

import java.awt.*;

class YesNo extends Dialog {

    public static final int UNDEFINED = 0, OK = 1, CANCEL = 2;

    private int state_ = UNDEFINED;

    public YesNo(String label, Frame parent) {

	super(parent, "Question?", true);

	//{{INIT_CONTROLS
	setLayout(null);
	addNotify();
	resize(insets().left + insets().right + 380, insets().top + insets().bottom + 136);

	labelText=new Label(label, Label.CENTER);
	labelText.setFont(new Font("Dialog", Font.BOLD, 10));
	add(labelText);
	labelText.resize(labelText.preferredSize());
	labelText.move(10,30);
	OKButton=new Button("Yes");
	add(OKButton);
	OKButton.reshape(insets().left + 98,insets().top + 71,77,33);
	cancelButton=new Button("No");
	add(cancelButton);
	cancelButton.reshape(insets().left + 203,insets().top + 71,77,33);
	//}}
    
	setResizable(false);
    }
  
    public synchronized void show() {
	Rectangle bounds = getParent().bounds();
	Rectangle abounds = bounds();
    
	move(bounds.x + (bounds.width - abounds.width)/ 2,
	     bounds.y + (bounds.height - abounds.height)/2);
    
	super.show();
    }
  
    public synchronized void wakeUp() {
	notify();
    }
  
    public boolean handleEvent(Event event) {
	if (event.id == Event.ACTION_EVENT && event.target == cancelButton) {
	    clickedCancelButton();
	    return true;
	}
	else
	    if (event.id == Event.ACTION_EVENT && event.target == OKButton) {
		clickedOKButton();
		return true;
	    }
	    else
	
		if (event.id == Event.WINDOW_DESTROY) {
		    hide();
		    return true;
		}
	return super.handleEvent(event);
    }

    //{{DECLARE_CONTROLS
    Label labelText;
    Button OKButton;
    Button cancelButton;
    //}}
  
    public void clickedOKButton() {
	state_ = OK;
	hide();
    }
  
    public void clickedCancelButton() {
	state_ = CANCEL;
	hide();
    }

    public int getState() {
	show();
	return state_;
    }
}


