
/*** A formal description file generated by j2s from source /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java ***/


/*** Generic lock/unlock definitions ***/

#define LOCK	0
#define UNLOCK	0
#define NOTIFY	1

#define __lock(object, inst_no, tid)          \
	object[inst_no].lock ? LOCK          

#define __unlock(object, inst_no, tid)             \
	object[inst_no].lock ! UNLOCK           

#define _lock(object, inst_no, tid)         \
	if                                     \
	:: (object[inst_no].pid != tid) -> \
	    object[inst_no].lock ? LOCK;    \
	    object[inst_no].pid = tid;     \
	:: else ->                             \
	    skip;                              \
	fi;                                    \
	object[inst_no].cnt ++             

#define _unlock(object, inst_no, tid)         \
	if                                     \
	:: (object[inst_no].cnt == 1) ->   \
	    object[inst_no].lock ! UNLOCK;  \
	    object[inst_no].pid = -1;      \
	:: else ->                             \
	    skip;                              \
	fi;                                    \
	object[inst_no].cnt --             

#define _wait1(object, inst_no, tid)    \
	object[inst_no].lock ! UNLOCK; \
	object[inst_no].nwait ++        

#define _wait2(object, inst_no, tid)    \
	object[inst_no].notify ? NOTIFY  

#define _wait3(object, inst_no, tid)    \
	object[inst_no].lock ? LOCK    

#define _notifyAll(object, inst_no, tid)              \
	do                                          \
	:: (object[inst_no].nwait > 0)  ->        \
		object[inst_no].nwait -- ;              \
		object[inst_no].notify ! NOTIFY;         \
	:: (object[inst_no].nwait == 0) -> break; \
	od

#define _notify(object, inst_no, tid)              \
	if                                          \
	:: (object[inst_no].nwait > 0)  ->        \
		object[inst_no].nwait -- ;              \
		object[inst_no].notify ! NOTIFY;         \
	:: (object[inst_no].nwait == 0) -> skip;  \
	fi

#define MAX_INSTANCES	11
#define MAX_ARRAY_SIZE	10

/*** Promela abstract type ***/

typedef REFERENCE {
	int i_no;
};


/*** Object synchronization type (non-recursive) ***/

typedef sync1_t {
	chan lock = [1] of { bit };
	chan notify = [0] of { bit };
	byte nwait;
};


/*** Object synchronization type (recursive) ***/

typedef sync2_t {
	chan lock = [1] of { bit };
	chan notify = [0] of { bit };
	byte nwait;
	int pid;
	byte cnt;
};


/*** Array types ***/

typedef bool_array {
	bool mem [MAX_ARRAY_SIZE];
};

typedef byte_array {
	byte mem [MAX_ARRAY_SIZE];
};

typedef short_array {
	short mem [MAX_ARRAY_SIZE];
};

typedef int_array {
	int mem [MAX_ARRAY_SIZE];
};

typedef REFERENCE_array {
	REFERENCE mem [MAX_ARRAY_SIZE];
};

byte java_lang_Thread_i_cnt = 0;
REFERENCE java_lang_Thread_super [MAX_INSTANCES];

/*** Instance variables for class `def_Fork' ***/

bool def_Fork_is_free [MAX_INSTANCES];
byte def_Fork_i_cnt = 0;
REFERENCE def_Fork_super [MAX_INSTANCES];

/*** Lock channels for class `def_Fork' ***/

sync1_t sync_def_Fork [MAX_INSTANCES];

/*** Instance variables for class `def_Philosopher' ***/

REFERENCE def_Philosopher_left [MAX_INSTANCES];
REFERENCE def_Philosopher_right [MAX_INSTANCES];
mtype def_Philosopher_status [MAX_INSTANCES];
byte def_Philosopher_i_cnt = 0;
REFERENCE def_Philosopher_super [MAX_INSTANCES];

/*** Class variables for class `def_Main' ***/

REFERENCE def_Main_fork1;
REFERENCE def_Main_fork2;
REFERENCE def_Main_phil1;
REFERENCE def_Main_phil2;

REFERENCE __null;
REFERENCE __abstract__;

/*** Thread states ***/

mtype = {ready, running, suspended, dead};

/*** Recursive functions ***/


/*** Thread `def.Philosopher' ***/

proctype thread0(REFERENCE this)
{{

skip;
in0:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 53 */
   if
   :: (!1) -> goto out1;
   :: (1) -> skip;
   fi;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 11 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __lock(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
in1:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 12 */
   if
   :: (!(! def_Fork_is_free [def_Philosopher_left [this.i_no].i_no])) -> goto out4;
   :: ((! def_Fork_is_free [def_Philosopher_left [this.i_no].i_no])) -> skip;
   fi;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 14 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      _wait1(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      skip;
   } 
   _wait2(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      _wait3(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      skip;
   } 
   goto in1;
out4:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 17 */
   def_Fork_is_free [def_Philosopher_left [this.i_no].i_no] = 0;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 18 */
out3:
   skip;
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __unlock(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 11 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __lock(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
in2:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 12 */
   if
   :: (!(! def_Fork_is_free [def_Philosopher_right [this.i_no].i_no])) -> goto out6;
   :: ((! def_Fork_is_free [def_Philosopher_right [this.i_no].i_no])) -> skip;
   fi;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 14 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      _wait1(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      skip;
   } 
   _wait2(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      _wait3(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      skip;
   } 
   goto in2;
out6:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 17 */
   def_Fork_is_free [def_Philosopher_right [this.i_no].i_no] = 0;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 18 */
out5:
   skip;
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __unlock(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 43 */
out2:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 21 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __lock(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 22 */
   def_Fork_is_free [def_Philosopher_left [this.i_no].i_no] = 1;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 23 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      _notify(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 24 */
out8:
   skip;
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __unlock(sync_def_Fork, def_Philosopher_left [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 21 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __lock(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 22 */
   def_Fork_is_free [def_Philosopher_right [this.i_no].i_no] = 1;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 23 */
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      _notify(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 24 */
out9:
   skip;
   atomic {
      (def_Philosopher_status [this.i_no] == running);
      if
      :: (1) ->
         __unlock(sync_def_Fork, def_Philosopher_right [this.i_no].i_no, _pid);
      :: else -> skip;
      fi;
      skip;
   } 
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 49 */
out7:
   skip;
   goto in0;
out1:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 57 */
out0:
   skip;
   def_Philosopher_status [this.i_no] = dead;
} unless { def_Philosopher_status [this.i_no] == dead }
}


/*** Main thread ***/

init
{
   REFERENCE _l40;
   REFERENCE _l41;
   REFERENCE _l42;
   REFERENCE _t40;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 68 */

/*** Initialization of lock channels ***/

   d_step {
      sync_def_Fork[0].lock ! LOCK;
      sync_def_Fork[1].lock ! LOCK;
      sync_def_Fork[2].lock ! LOCK;
      sync_def_Fork[3].lock ! LOCK;
      sync_def_Fork[4].lock ! LOCK;
      sync_def_Fork[5].lock ! LOCK;
      sync_def_Fork[6].lock ! LOCK;
      sync_def_Fork[7].lock ! LOCK;
      sync_def_Fork[8].lock ! LOCK;
      sync_def_Fork[9].lock ! LOCK;
      sync_def_Fork[10].lock ! LOCK;
   }

/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 69 */
   d_step {
      skip;
      def_Fork_i_cnt ++;
      assert(def_Fork_i_cnt < MAX_INSTANCES);
      _t40.i_no = def_Fork_i_cnt;
   }
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 7 */
   def_Fork_is_free [_t40.i_no] = 1;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 8 */
out11:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 69 */
   def_Main_fork1.i_no = _t40.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 70 */
   d_step {
      skip;
      def_Fork_i_cnt ++;
      assert(def_Fork_i_cnt < MAX_INSTANCES);
      _t40.i_no = def_Fork_i_cnt;
   }
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 7 */
   def_Fork_is_free [_t40.i_no] = 1;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 8 */
out12:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 70 */
   def_Main_fork2.i_no = _t40.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 72 */
   d_step {
      skip;
      def_Philosopher_i_cnt ++;
      assert(def_Philosopher_i_cnt < MAX_INSTANCES);
      _t40.i_no = def_Philosopher_i_cnt;
   }
   def_Philosopher_status [_t40.i_no] = ready;
   _l41.i_no = def_Main_fork1.i_no;
   _l42.i_no = def_Main_fork2.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 35 */
   def_Philosopher_left [_t40.i_no].i_no = _l41.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 36 */
   def_Philosopher_right [_t40.i_no].i_no = _l42.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 37 */
out13:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 72 */
   def_Main_phil1.i_no = _t40.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 73 */
   d_step {
      skip;
      def_Philosopher_i_cnt ++;
      assert(def_Philosopher_i_cnt < MAX_INSTANCES);
      _t40.i_no = def_Philosopher_i_cnt;
   }
   def_Philosopher_status [_t40.i_no] = ready;
   _l41.i_no = def_Main_fork1.i_no;
   _l42.i_no = def_Main_fork2.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 35 */
   def_Philosopher_left [_t40.i_no].i_no = _l41.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 36 */
   def_Philosopher_right [_t40.i_no].i_no = _l42.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 37 */
out14:
   skip;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 73 */
   def_Main_phil2.i_no = _t40.i_no;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 75 */
   if
   ::    atomic {
      (def_Philosopher_status [def_Main_phil1.i_no] == ready);
      def_Philosopher_status [def_Main_phil1.i_no] = running;
      run thread0(def_Main_phil1);
      skip;
   } 
   :: else -> skip;
   fi;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 76 */
   if
   ::    atomic {
      (def_Philosopher_status [def_Main_phil2.i_no] == ready);
      def_Philosopher_status [def_Main_phil2.i_no] = running;
      run thread0(def_Main_phil2);
      skip;
   } 
   :: else -> skip;
   fi;
/* line: /Users/radu/Work/teaching/ENS_Lyon_10_01_2012/java2spin-1.0/samples/Phil1.java 77 */
out10:
   skip;

}

